$    ver = 'f$verify(0)
$!-  Must have a parameter
$    if p1 .eqs. "" then goto e_finish
$
$    true	 = 1 .and. 1
$    false	 = 1 .and. 0
$    cd$last	 = f$environment("DEFAULT")
$    cd$host	 = f$edit(f$getsyi("NODENAME"), "TRIM")
$    cd$esc[0,8] = 27
$    cd$csi[0,8] = 155
$
$    if p1 .nes. "_$_PWD_$_" then goto 005$
$    write sys$output "  CUR  = ", f$environment("DEFAULT")
$    write sys$output "  LAST = ", f$trnlnm("LAST",,,,,"VALUE")
$    goto finish
$
$ 005$:
$    if p1 .nes. "_$_BK_$_"  then goto 010$
$    set default last
$    goto moved
$
$ 010$:
$    if p1 .nes. "SETUP" then goto 015$
$    proc  = f$environment("PROCEDURE")
$    comf  = f$parse(proc,,,"NAME")
$    where = f$element(0, "]", proc) + "]"
$    cd   == "@" + where + comf + " %"
$    pwd  == "@" + where + comf + " _$_PWD_$_"
$    bk   == "@" + where + comf + " _$_BK_$_"
$    define/job/nolog cur  'f$environment("DEFAULT")
$    define/job/nolog home 'f$trnlnm("SYS$LOGIN")
$    if p2 .eqs. "" then goto 012$
$    prompt_format == "''p2'"
$
$ 012$:
$    if p3 .eqs. "" then goto 014$
$    prompt_params == "''p3'"
$
$ 014$:
$    goto finish
$
$ 015$:
$    if p1 .eqs. "%" then p1 = p2
$    if p1 .nes. "" then goto skip
$
$ no_parameter:
$    set def sys$login
$    goto moved
$
$ skip:
$    dev	= f$parse(cd$last,,, "DEVICE")
$    dir	= f$parse(cd$last,,, "DIRECTORY") - "[" - "]"
$    at_top	= dir .eqs. "000000"
$    str	= f$edit(p1, "COLLAPSE, UPCASE")
$    ndir	= ""
$    mdv	= dev
$
$    if str .nes. ".." then goto 040$
$    set default [-]
$    goto moved
$
$ 040$:
$    if f$parse("[.''str']") .eqs. "" then goto 045$	! Valid VMS?
$    if at_top
$	then set default ['str]
$	else set default [.'str]
$    endif
$    goto moved
$
$ 045$:
$    if f$parse(str) .eqs. "" then goto 050$
$    set default 'str
$    goto moved
$
$ 050$:
$    if str .nes. "/" 	then goto 055$
$    set default sys$sysdevice:[000000]
$    goto moved
$
$ 055$:
$    if str .nes. "~" then goto 057$
$    set default sys$login
$    goto moved
$
$ 057$:
$    absolute	= false
$    im_at	= f$environment("DEFAULT")
$    dir_at	= f$parse(im_at,,,"DIRECTORY")
$    if f$verify() then show symbol im_at
$    if f$verify() then show symbol dir_at
$
$    if dir_at .eqs. "[000000]"
$	then move_to  = im_at - "000000]"
$	     absolute = true
$	else move_to  = im_at - "]"
$    endif
$    if f$verify() then show symbol move_to
$    ecnt	= 0
$    element	= f$element(ecnt, "/", str)
$    if element .eqs. ""
$	then ecnt     = ecnt + 1
$	     element  = f$element(ecnt, "/", str)
$	     move_to  = element + ":["
$	     absolute = true
$	else if element .eqs. "~"
$		then move_to  = f$trnlnm("SYS$LOGIN") - "]"
$		     absolute = false
$		else ecnt     = ecnt - 1
$	     endif
$    endif
$
$    lcnt	= ecnt
$
$ down_loop:
$    lcnt	= lcnt + 1
$    element    = f$element(lcnt, "/", str)
$    if element .eqs. "/" then goto down_loop_end	! Loop exit condition
$    if element .eqs. ".." then element = "-"
$    if absolute
$	then move_to  = move_to + element
$	     absolute = false
$	else move_to  = move_to + "." + element
$    endif
$    if f$verify() then show symbol move_to
$    goto down_loop
$
$ down_loop_end:
$    elements = lcnt - ecnt
$    if absolute .and. (elements .le. 1)
$	then move_to = move_to + "000000]"
$	else move_to = move_to + "]"
$    endif
$    if f$verify() then show symbol move_to
$    if f$parse(move_to) .eqs. "" then goto e_finish
$    set default 'move_to
$    goto moved
$
$ moved:
$    cd$cur = f$environment("DEFAULT")
$    write sys$output "  ", cd$cur
$    if cd$last .eqs. cd$cur then goto finish
$    define/nolog/job cur 'cd$cur
$    define/nolog/job last 'cd$last
$    goto finish
$
$ e_finish:
$    write sys$output "  `''P1'` Is not valid."
$    goto finish
$
$ finish:
$    if (("''prompt_format'")) .nes. "" .and. -
	(("''prompt_params'") .nes. "")
$	then cd$cur	 = f$environment("DEFAULT")
$	     cd$dir	 = f$element(1, ":", cd$cur)
$	     cd$dir_raw	 = cd$dir - "[" - "]"
$	     cd$device   = f$element(0, ":", cd$cur)
$	     p$string    = f$fao(prompt_format, 'prompt_params)
$	     if f$length(p$string) .gt. 32 then -
		p$string = f$extract(0, 29, p$string) + "..."
$	     set prompt="''p$string'"
$    endif
$    ver = f$verify(ver)
