$    set noon
$
$!-  Local symbols
$    __		= "WRITE SYS$OUTPUT"
$    _f		= "WRITE FDL"
$    SS$_NORMAL	= 1		! From SYS$LIBRARY:SSDEF.H
$    RMS$_FNF   = 98962		! From SYS$LIBRARY:RMSDEF.H
$    exit$sts	= SS$_NORMAL
$
$!-  Input parameter???
$    if p1 .eqs. "" then goto no_p1
$
$!-  Build temporary filename for the FDL...
$    pid   = f$getjpi(0,"PID")
$    fdl   = "SYS$SCRATCH:STREAM_LF_''pid'.FDL"
$
$!-  Where's the input file???
$    iname = f$search(p1)
$    if iname .eqs. "" then goto bad_p1
$    fname = f$parse(iname,,, "NAME")
$    if p2 .eqs. ""
$ 	then oname = f$parse(fname,".STREAM",,, "SYNTAX_ONLY")
$	else oname = f$parse(p2, ".STREAM",,,"SYNTAX_ONLY")
$    endif
$
$!-  How big is the input file???
$    ialq = f$file_attributes(iname, "ALQ")
$
$!-  Create the FDL...
$    create/fdl=sys$input 'fdl
FILE
	ALLOCATION		1
	ORGANIZATION            sequential
RECORD
	BLOCK_SPAN              yes
	CARRIAGE_CONTROL        carriage_return
	FORMAT                  variable
	SIZE                    0
$    exit$sts = $status
$    if exit$sts then goto 005$
$    __ "Creation of temporary FDL ", fdl, " failed"
$    exit 'exit$sts
$
$ 005$:
$    open/append fdl 'fdl
$    _f "FILE
$    _f "	ORGANIZATION            SEQUENTIAL"
$    _f "	ALLOCATION		", ialq
$    _f "RECORD"
$    _f "	BLOCK_SPAN              YES"
$    _f "	CARRIAGE_CONTROL        CARRIAGE_RETURN"
$    _f "	FORMAT                  STREAM_LF"
$    close fdl
$    return
$
$    __ "Converting ", iname
$    __ "        to ", oname
$    convert/fdl='fdl 'iname 'oname
$    exit$sts = $status
$    if f$search(oname) .nes. "" then set file/truncate 'oname
$    if f$search(fdl)   .nes. "" then delete/nolog/noconf 'fdl;*
$    exit 'exit$sts
$
$ no_p1:
$   __ "Usage: VMSTOUNIX <input-file> [<output-file>]"
$   exit 'SS$_NORMAL
$
$ bad_p1:
$   __ "Input file ", p1, " could not be opened"
$   exit 'RMS$_FNF
$
$!-
$!   This procedures converts a standard VMS text or VFC file into a 
$!   Stream_LF (UNIX and PC) file. (Brian, 12-19-91)
$!
$!      UMKC    UMKCUMKCUMKCUMKC           Brian McKeever
$!      UMKC    UMKCUMKCUMKCUMKC                 MCKEEVER@CSTP.UMKC.EDU
$!      UMKC    UMKCUMKCUMKCUMKC                 MCKEEVER@UMKCVAX2.BITNET
$!       UM     UMKCUMKC       U           
$!  U           UMKCUM                     University of Missouri - Kansas City
$!  UMKC     UMKCUMKC      UM      UM      Computer Science Program
$!  UMKCUMKCUMKCUMKCU     UMKC    UMKC     VMS Systems & Network Manager
$!  UMKCUMKCUMKCUMKCU     UMKC    UMKC     (816) 235-2368
$!  UMKCUMKCUMKCUMKCU     UMKC    UMKC     (816) 235-5159 - FAX
$!-
